// TICKER   This applet is copyright (c) 1998-2002 by methodica herger & krasznai
//          Address:   Fellstr. 3, P.O. Box 39, CH-5413 Switzerland
//          Internet:  http://www.methodica.ch, mail@methodica.ch
//
//          Purpose:   The applet displays a line of text at a time,
//                     the text beeing delivered by a text server class.
//
//          The text can be specified using one of two
//          methods:
//               - via "PARAM NAME=Text VALUE=...." from a HTML page.
//                 (Together with the standard DEFTEXT.CLASS, the TEXT
//                 parameter may either specify a text string or the name
//                 of an ASCII text file containing 1 or more lines of text.)
//               - via a class named DEFTEXT.CLASS, which must export the
//                 same public methods as the standard DEFTEXT.CLASS does.
//
//          Note:  Since you may replace the DEFTEXT.CLASS by your own,
//                 you are totally free on how the text this applet will
//                 display is generated. However, there *must* be such a
//                 class in the default Java directory or in the same
//                 directory as the TICKER.CLASS (this) is stored.
//
//          This code is freeware.
//          You are free to use and modify it, as long as due credit is
//          given, and the resulting source code is made available to the
//          public too.
//          If you use this code, drop us a line ("mail@methodica.ch"), so
//          that we know, how many people are using it, and what an impact
//          modifications to it will have.
//
//          The code is given to the public domain on an "as is" basis.
//          This means, that neither the author, nor methodica can be made
//          responsible under any circumstances for damages caused by this
//          applet or malfunctions of this applet. Since the source code
//          is published, you might convince yourself of the fact, that the
//          applet contains no offending or destructive code.
//
//          1998-12-23, Hans E. Herger <hans.herger@methodica.ch>
//          2001-11-26, Hans E. Herger <hans.herger@methodica.ch>
//                      Target addressing introduced.
//          2002-02-28, Hans E. Herger <hans.herger@methodica.ch>
//                      Logging feature introduced.
//                      Note: needs a server side scripts such as
//                            "setlogent.cgi".

import java.applet.*;
import java.awt.*;
import java.net.*;
import java.lang.Object;
import java.lang.InstantiationException;
import java.lang.IllegalAccessException;
import java.lang.NullPointerException;

import logger;


public class ticker extends Applet implements Runnable
{
   Thread  m_tickerThread = null;

    // applet properties and default values (where applicable)
	protected int     m_Rate       = 40;   // time between scroll steps (in milliseconds)
	protected int     m_Spacing    = 1;    // scroll step (in pixels)
	protected int     m_PDelay     = 1000; // time (in milliseconds) to wait after each text page
	protected int     m_BStyle     = 1;    // border style: 0-none, 1-lowered, 2-raised
	protected int     m_BThickness = 2;    // border thickness in pixels
	protected Color   m_BColor     = null; // new Color(0x7F7F7F); // medium border color
	protected int     m_BMargin    = 2;    // border_to_text margin in pixels
	protected Color   m_BGColor    = null; // background color; default taken from window
	protected Color   m_TColor     = null; // text color; default: inversed background color
	protected Color   m_THColor    = new Color(0xFF0000); // text highlight color
	protected String  m_TFont;             // textfont name (*)
	protected int     m_TStyle;            // text style: 0-plain, 1-bold, 2-italic, 3-bold+italic (*)
	protected int     m_TSize;             // text size in pixels (*)
   protected String  m_DTClass    = "";   // Class delivering text lines
	protected String  m_Text       = "";   // default text, init always!
	protected String  m_URL        = "";   // default URL, init always!
	protected String  m_URLfromParam = ""; // URL as input via PARAM statement
	protected int     m_Direction  = 0;    // scroll direction: 0 - to left, 1 - to right
	                                       // (*): initialized from default font configured by the user
   protected int     m_ShadeDist  = 4;    // Horizontal and vertical distance of shadow from text.
   protected int     m_ShadeWidth = 0;    // Width of shade
   protected String  m_TFile = null;      // name of input file
   protected String  m_Target = "_self";  // Target, where to show document
   protected String  m_TargetfromParam = "_self"; // Target as input via PARAM statement
   protected boolean m_bNoLog = false;    // Set to "ON" to suppress logging, default = "OFF"

   protected logger lg = null;

	public static final int lightest = 100;
	public static final int light = 80;
	public static final int mid = 60;
	public static final int dark = 40;
	public static final int darkest = 20;

   private final String PARAM_Rate         = "Rate";
   private final String PARAM_Spacing      = "Spacing";
   private final String PARAM_PDelay       = "PageDelay";
   private final String PARAM_BStyle       = "BorderStyle";
   private final String PARAM_BThickness   = "BorderThickness";
   private final String PARAM_BColor       = "BorderColor";
   private final String PARAM_BMargin      = "BorderMargin";
   private final String PARAM_BGColor      = "BackgroundColor";
   private final String PARAM_TColor       = "TextColor";
   private final String PARAM_THColor      = "HighlightColor";
   private final String PARAM_TFont        = "TextFont";
   private final String PARAM_TStyle       = "TextStyle";
   private final String PARAM_TSize        = "TextSize";
   private final String PARAM_DTClass      = "TextServer";
   private final String PARAM_Text         = "Text";
   private final String PARAM_TextFile     = "TextFile";
   private final String PARAM_URL          = "URL";
   private final String PARAM_Target       = "Target";
   private final String PARAM_Width        = "Width";
   private final String PARAM_Height       = "Height";
   private final String PARAM_Direction    = "Direction";
   private final String PARAM_ShadowDist   = "ShadowDistance";
   private final String PARAM_ShadowWidth  = "ShadowWidth";
   private final String PARAM_NoLog        = "NoLog";

	private final String sTextFromFileClass = "fildtxt";
	private final String sDefaultTextClass  = "deftext";
	private final String sLogTextClass      = "logger";
	private String       sDefaultText       = "";
	private boolean      m_bDynLoadServer   = true;

   private Image m_image;          // double buffering: off-screen image
   private Dimension m_dimImage;   // size of off-screen image
   private Graphics m_g;           // associated graphics object
   private int m_nHOffset;         // actual horizontal text offset
   private int m_nVOffset;         // actual vertical text offset
   private int m_nStartPos;        // text start position
   private int m_nEndPos;          // text end position
   private int m_nShade = 0;       // additional x/y text shadow size
	private Color m_BLight;         // light border color
	private Color m_BDark;          // dark border color
	private int m_Step = -1;        // scrolling step width and scrolling direction
	private Rectangle m_origBounds; // the applet window including the border
	private Rectangle m_textBounds; // the text window only
	private int m_Wait = 0;         // actual time to wait in milliseconds
	private Font m_Font = null;     // the text font to use
	private boolean m_bMouseOver = false; // flag, set while the mouse flies
	                                      // over the applet window
	private int m_nTmp;             // a temporary integer type working storage cell

	private Class TextServerClass = null;
   private txtsrvr TextServer = null;
	private boolean firsttime = true;

   // these color names may be used to specify background, foreground,
   // highlight, and border colors
	static  protected String colorname[] =
				     {"black","blue","cyan",
			              "darkgray","gray","green",
			              "lightgray","magenta","orange",
			              "pink","red","white",
			              "yellow"};
	static  protected Color colorobject[] =
			             {Color.black,Color.blue,Color.cyan,
			              Color.darkGray,Color.gray,Color.green,
			              Color.lightGray,Color.magenta,Color.orange,
			              Color.pink,Color.red,Color.white,
			              Color.yellow};
	static  int ncolorinfo = 13;
   static  String emptyString = "";

   // Standard constructor
   //----------------------------------------------------------------------
   public ticker() {
	}


   // Standard destructor
   //----------------------------------------------------------------------
	public void finalize() {
	}

   // Standard method: provides applet information upon request
   //----------------------------------------------------------------------
	public String getAppletInfo() {
		return "TICKER 2.6 - by Hans E. Herger - " +
		       "Copyright (C) 1997-2002, methodica herger-krasznai";
	}

   // Standard method: provides parameter information upon request
   //----------------------------------------------------------------------
	public String[][] getParameterInfo() {
		String[][] info =
		{
         // { "[Name]",         "[Type]",   "[Description]"},
         { PARAM_Rate,       "int",      "Scroll rate" },
         { PARAM_Spacing,    "int",      "Spacing / step width in pixels" },
         { PARAM_PDelay,     "int",      "Delay at page / text end" },
         { PARAM_BStyle,     "int",      "Border style (0-none, 1-raised, 2-lowered)" },
         { PARAM_BThickness, "int",      "Border thickness" },
         { PARAM_BColor,     "color",    "Border (medium) color (RGB or name)" },
         { PARAM_BMargin,    "int",      "Border margin versus text" },
         { PARAM_BGColor,    "color",    "Background color (RGB or name)" },
         { PARAM_TColor,     "color",    "Text color (RGB or name)" },
         { PARAM_THColor,    "color",    "Highlight color for hyperlinks (RGB or name)" },
         { PARAM_TFont,      "string",   "Text font" },
         { PARAM_TStyle,     "int",      "Text style (0-plain, 1-bold, 2-italics, 3-bold+italics)" },
         { PARAM_TSize,      "int",      "Text size" },
         { PARAM_DTClass,    "string",   "Name of text server class to use instead of DEFTEXT.CLASS" },
         { PARAM_Text,       "string",   "Line of text to display" },
         { PARAM_TextFile,   "string",   "Name of a file of text lines to display" },
         { PARAM_URL,        "string",   "Hyperlink URL" },
         { PARAM_Target,     "string",   "Document target" },
         { PARAM_Width,      "int",      "Window width" },
         { PARAM_Height,     "int",      "Window height" },
         { PARAM_Direction,  "int",      "Scroll direction; 0-left, 1-right" },
         { PARAM_ShadowDist, "int",      "Distance of shadow from text [in pixels]" },
         { PARAM_ShadowWidth,"int",      "Shadow width [in pixels], 0(null) = no shadow" },
         { PARAM_NoLog,      "string",   "Logging suppressed if YES/ON" }
      };
		return info;
	} // method getParameterInfo()

   public void extractURL(String stext) {
      if (stext == null) return;

      m_Target = "";
      int i = stext.indexOf("|");
      if (i > -1) {
         m_Text = stext.substring(0,i);
         m_URL  = stext.substring(i+1);
         i = m_URL.indexOf("|");
         if (i > -1) {
            m_Target = m_URL.substring(0,i);
            m_URL  = m_URL.substring(i+1);
         }
      }
      else {
         m_Text = stext;
         m_URL  = "";
      }
      if (m_URL.length() < 1) { m_URL = m_URLfromParam; }
      if (m_Target.length() < 1) { m_Target = m_TargetfromParam; }
      if (m_bMouseOver) {  showStatus(m_URL); }

   } // method extractURL(..)


   // Public method: allows for dynamically changing the text specified by
   // the "Text" parameter. The newText(String) method can even be called
   // from a scripting language such as JavaScript.
   // Example:
   // <APPLET NAME="C1" CODEBASE="applets/" CODE="ticker.class"
   // WIDTH="436" HEIGHT="16" HSPACE="0">
   // <PARAM NAME="BackgroundColor" VALUE="EFEFEF">
   // <PARAM NAME="BorderMargin" VALUE="0">
   // <PARAM NAME="BorderStyle" VALUE="0">
   // <PARAM NAME="Text" VALUE="">
   // <APPLET>
   //         [...]
   //         C1.newText("HTML says hello to the APPLET C1")
   //--------------------------------------------------------------------------
   public void newText(String stext) {

      m_Text = stext;
      extractURL(m_Text);
      repaint();
      return;

   } // method newText(..)

   // Determines a color from a name string, a decimal or hexadecimal RGB value
   //--------------------------------------------------------------------------
	protected Color fromString(String scolor, Color defcolor) {

      Integer i;
   	int j;
   	try {
         i = Integer.valueOf(scolor, 16);
   		return new Color(i.intValue());
      }
   	catch (NumberFormatException e) {
         String cname;
         if (scolor != null) {
            j = 0;
       		while (j<ncolorinfo) {
               cname = colorname[j];
       			if (cname.equalsIgnoreCase(scolor)) {return colorobject[j];  }
               j++;
            } // while (j<ncolorinfo)
         }
			return (defcolor);
      } // catch (NumberFormatException)
	} // method fromString(..)

	// Calculates dimmed or higlighted variants of a color
	// corresponding to a highlight style (lightest .. darkest)
        //----------------------------------------------------------------------
	protected Color calcColor(Color oC, int style) {

		int r = oC.getRed();  int b = oC.getBlue();  int g = oC.getGreen();
		int s,t;

		s = (b>r) ? ( (b>g) ? b : g ) : ( (r>g) ? r : g );
		t = s + 0x64;
		if (t > 0xFF) { t = 0xFF; }
		r = t * r / s;  b = t * b / s;   g = t * g / s;

		if (style > lightest)   {  s = lightest;  }
		else
		if (style < darkest)    {  s = darkest;  }
		else                    {  s = style;  }
		r = (r * s) / 100;  g = (g * s) / 100;  b = (b * s) / 100;
		return new Color(r,g,b);

	} // end of method calcColor


   // Sets the start and end positions corr. to the length of text to show
   //----------------------------------------------------------------------
   public void setStartAndEndPos() {

      if (m_Text == null) { return; }
      FontMetrics fm = getFontMetrics(getFont());
      m_nVOffset = -fm.getMaxDescent();
      int sw = -fm.stringWidth(m_Text)-6;
      // We enforce scrolling when there is not enough space to display
      // the entire text in the window.
      if (sw > (m_textBounds.width - (m_BMargin * 2))) {  m_Spacing = 1; }
      if (m_Spacing < 1) {
         // When scroll step width is 0 (null), and scrolling direction is
         // left to right, we assume right adjustment of text.
         m_nStartPos = (m_Direction == 0) ?
            m_BMargin * 2 :
            m_textBounds.width - m_BMargin + sw;
         m_nStartPos -= (m_Direction == 0) ?
            (m_nShade > 0) ? 0 : m_nShade :
            Math.abs(m_nShade);
         m_nEndPos = m_textBounds.width + (m_BMargin * 2);
      } // (m_Spacing < 1)
      else {
         int p1 = sw + m_BMargin;
         int p2 = m_textBounds.width + (m_BMargin * 2);
         p1 -= (m_nShade > 0) ? m_nShade : 0;
         p2 -= (m_nShade < 0) ? m_nShade : 0;
         m_Step =        (m_Direction == 0) ? -1 : +1;
         m_nEndPos =     (m_Direction == 0) ? p1 : p2;
         m_nStartPos =   (m_Direction == 0) ? p2 : p1;
      } // !(m_Spacing < 1)
      m_nHOffset = m_nStartPos;

   } // end of method setStartAndEndPos

   // Standard method: initializes the applet
   //----------------------------------------------------------------------
   public void init() {

	   String param, stwork;
	   int xi;

	   super.init();

	   setLayout(null);
      addNotify();
	   resize(430,270);
	   // setFont(new Font("Dialog", Font.BOLD, 12));
	   setForeground(new Color(0));
      setBackground(new Color(16777215));


      m_Font = getFont();
      if (m_Font != null) {
         m_TFont = m_Font.getName();
         m_TSize = m_Font.getSize();
         m_TStyle = m_Font.getStyle();
      }

      param = getParameter(PARAM_Rate);
	   if (param != null) m_Rate = Integer.parseInt(param);
	   param = getParameter(PARAM_Spacing);
	   if (param != null) m_Spacing = Integer.parseInt(param);
	   param = getParameter(PARAM_PDelay);
	   if (param != null) m_PDelay = Integer.parseInt(param);
	   param = getParameter(PARAM_BStyle);
	   if (param != null) m_BStyle = Integer.parseInt(param);
	   if (m_BStyle > 2) m_BStyle = 2;
	   if (m_BStyle < 0) m_BStyle = 0;
	   param = getParameter(PARAM_BThickness);
      if (param != null) m_BThickness = Integer.parseInt(param);

      if (m_BGColor == null)
         {m_BGColor = getBackground();}
      if (m_TColor == null)
         {m_TColor = new Color(m_BGColor.getRGB() ^ 0xFFFFFF);}

	   param = getParameter(PARAM_BColor);
	   if ((param == null) && (m_BColor == null)) {  m_BColor = m_BGColor;  }
	   else {
         m_BColor = fromString(param, m_BColor); }
         if ((m_BThickness == 0) || (m_BStyle == 0)) {
	         m_BLight = m_BColor;
	         m_BDark = m_BColor;
         }
	      else {
	      if (m_BStyle == 1) {
	         m_BLight = calcColor(m_BColor, dark);
	         m_BDark  = calcColor(m_BColor, light);
	      }
	      else {
	         m_BLight = calcColor(m_BColor, light);
	         m_BDark  = calcColor(m_BColor, dark);
	      }
      }

	   param = getParameter(PARAM_BMargin);
	   if (param != null) {  m_BMargin = Integer.parseInt(param);  }
      param = getParameter(PARAM_BGColor);
	   m_BGColor = fromString(param, m_BGColor);
	   param = getParameter(PARAM_TColor);
	   m_TColor = fromString(param, m_TColor);
	   param = getParameter(PARAM_THColor);
	   m_THColor = fromString(param, m_THColor);
	   param = getParameter(PARAM_TFont);
	   if (param != null) {  m_TFont = param; }
	   param = getParameter(PARAM_TStyle);
      if (param != null) {
	      m_nTmp = Integer.parseInt(param);
	      m_TStyle = Font.PLAIN;
	      if ((m_nTmp & 1) == 1)  {  m_TStyle = m_TStyle + Font.BOLD;  }
	      if ((m_nTmp & 2) == 2)  {  m_TStyle = m_TStyle + Font.ITALIC;  }
	   }
	   param = getParameter(PARAM_TSize);
	   if (param != null) {  m_TSize = Integer.parseInt(param);  }
	   param = getParameter(PARAM_DTClass);
	   if (param != null) {  m_DTClass = param;  }

      param = getParameter(PARAM_Text);
	   if (param != null) {
         m_Text = param;
	      m_bDynLoadServer = false;
	      // If neither the TEXT nor the TEXTSERVER parameters are specified,
	      // then the applet usually would call the DEFTEXT.CLASS to get a
	      // default text.
	      // An empty TEXT parameter (with no or an empty VALUE string) readies
	      // the applet to accept text via the "newText(String)" method.
	      // See there for details.
         newText(m_Text);
      }

	   param = getParameter(PARAM_TextFile);
	   if (param != null) {
	      m_TFile = param;
	      if (m_TFile.length() > 1) {
	         if (m_DTClass.length()<1) {
               m_DTClass = new String(sTextFromFileClass);
            }
	         m_bDynLoadServer = true;
         }
      }

      if (m_bDynLoadServer && (m_DTClass.length() < 1)) {
         m_DTClass = new String(sDefaultTextClass);
	   }

      if (m_bDynLoadServer) {
         // Dynamically load a text server
         try {
	         TextServerClass = Class.forName(m_DTClass);
	         TextServer = (txtsrvr)TextServerClass.newInstance();
	         // set server specific parameters (e.g. Y2KDTXT_1)
            for (xi=1; xi<10; xi++) {
               stwork = m_DTClass + "_" + xi;
               param = getParameter(stwork);
    	         if (param != null) {
                  TextServer.putParameter(stwork, param);
               }
            }
         }
         catch (ClassNotFoundException cnfe1) {
	         m_bDynLoadServer = false;
	         m_Text = cnfe1 + " Couldn't find class " + m_DTClass;
         }
	      catch (InstantiationException ie1) {
            m_bDynLoadServer = false;
	         m_Text = ie1 + " Couldn't instantiate class " + m_DTClass;
         }
	      catch (IllegalAccessException iae1) {
	         m_bDynLoadServer = false;
	         m_Text = iae1 + " Couldn't access class " +
                m_DTClass + " due to security reasons.";
         }
	      catch (NoSuchMethodError nse1) {
	         m_bDynLoadServer = false;
            m_Text = nse1 +
               " A class method (probably the constructor) " +
               "was not found in class " + m_DTClass;
         }
      } // if (m_bDynLoadServer)

      URL xURL = null;

      if (m_bDynLoadServer) {
         if (m_DTClass.equalsIgnoreCase(sTextFromFileClass)) {
            // Initialize the FILDTXT text server to get text from a (URL) file
            try {  xURL = new URL(m_TFile);  }
            catch (MalformedURLException e) {
               try {  xURL = new URL(getDocumentBase(), m_TFile);  }
               catch (MalformedURLException e1) {}
            }
            m_bDynLoadServer = TextServer.initText(xURL, emptyString, 0, 0);
         }
         else {
            // Initialize any text server.
            // Usually specific parameteres are interpreted by the server's
            // initText() methods
            TextServer.initText(null, null, 0, 0);
         }
      } // if (m_bDynLoadServer)

      param = getParameter(PARAM_URL);
	   if (param != null) {
         m_URL = param;
         m_URLfromParam = param;
	   }

      param = getParameter(PARAM_Target);
      if (param != null)  {
         m_Target = param;
         m_TargetfromParam = param;
      }

      if (m_bDynLoadServer) {
         // Get a line of text from the text server
         m_Text = TextServer.getText();
         extractURL(m_Text);
      }

      param = getParameter(PARAM_Direction);
	   if (param != null) {  m_Direction = (Integer.parseInt(param)) % 2;  }
	   m_origBounds = this.getBounds();

      param = getParameter(PARAM_ShadowDist);
      if (param != null) {  m_ShadeDist = Integer.parseInt(param);  }

      param = getParameter(PARAM_ShadowWidth);
      if (param != null) {  m_ShadeWidth = Integer.parseInt(param);  }
      if (m_ShadeWidth < 0) {  m_ShadeWidth = 0;  }
      m_nShade = (m_ShadeWidth > 0) ?
         (m_ShadeDist<0) ?
            m_ShadeDist - m_ShadeWidth :
            m_ShadeDist + m_ShadeWidth :
         0;

      param = getParameter(PARAM_Width);
      if (param != null) {  m_origBounds.width = Integer.parseInt(param);  }

      param = getParameter(PARAM_Height);
	   if (param != null) {  m_origBounds.height = Integer.parseInt(param);  }

      resize(m_origBounds.width, m_origBounds.height);
      AdjustTextRect();
      m_Font = new Font(m_TFont, m_TStyle, m_TSize);
      setFont(m_Font);
      setStartAndEndPos();

      // Log applet usage if configured so
      param = getParameter(PARAM_NoLog);
      if (param != null) {
         m_bNoLog = (param.equalsIgnoreCase("ON") ||
                     param.equalsIgnoreCase("YES"));
      }
      if (!m_bNoLog) {
         xURL = getDocumentBase();
         String db = xURL.getProtocol() + "://" + xURL.getHost() +
            xURL.getFile();
         xURL = getCodeBase();
         String cb = xURL.getProtocol() + "://" + xURL.getHost() +
            xURL.getFile();

         lg = new logger();
         if (lg != null) {
            lg.initLog(cb, db);
            lg.doLog(getAppletInfo() +
               (m_DTClass.length()>0 ? " - Srvr " + m_DTClass : ""));
         }
      } // if (!m_bNoLog)

   } // method init


   // Standard method: destroys the applet
   //--------------------------------------------------------------------------
	public void destroy() {

      if (m_bDynLoadServer) {
         // Give the the text server the chance to do cleanup
         TextServer.exitText();
      }

	} // end of method destroy


   // Standard method: paint the applet window
   //--------------------------------------------------------------------------
	public void paint(Graphics g) {

      if (m_image == null) return;
      // repaint the off-screen image
      g.drawImage(m_image, 0, 0, null);

	} // end of method paint



   // Update an offscreen (to avoid flicker) image of the applet window
   //--------------------------------------------------------------------------
   public void update(Graphics g) {
      // make sure the image is the same size as the applet window
      ResizeImage();

      // Clear the off-screen image
      // Note: "m_g" is the off-screen image buffer,
      //       "g" is the on-screen image buffer
      if (m_BGColor != null) {  m_g.setColor(m_BGColor);  }
      m_g.fillRect(0, 0, m_origBounds.width, m_origBounds.height);

      // Paint the frame and text (offscreen)
      PaintFrame(m_g);
      PaintData(m_g);

      // Repaint the (onscreen) image
      paint(g);

   } // end of method update



   // paint the window frame
   //--------------------------------------------------------------------------
   private void PaintFrame(Graphics g) {

      int xc, xm;
      if (m_BThickness < 1) return;
      if ((m_origBounds.width < 2) || (m_origBounds.height < 2)) return;

      g.setColor(m_BLight);
      g.fillRect(0, 0, m_origBounds.width, m_BThickness);
      g.fillRect(0, 0, m_BThickness, m_origBounds.height);
      g.setColor(m_BDark);
      xc = 0;
      while (xc < m_BThickness) {
         g.drawLine(xc, m_origBounds.height-1-xc,
            m_origBounds.width-1, m_origBounds.height-1-xc);
         xc++;
      }
      xc = 0;
      while (xc < m_BThickness) {
         g.drawLine(m_origBounds.width-1-xc, m_origBounds.y+xc,
            m_origBounds.width-1-xc, m_origBounds.height-1);
         xc++;
      }

   } // end of method PaintFrame


   // adjust the horizontal text offset while scrolling
   //--------------------------------------------------------------------------
   private void AdjustHOffset() {

      boolean bEndReached;

//    if (m_Spacing < 1) {}
      if (m_Step < 0) {  bEndReached = (m_nHOffset < m_nEndPos);  }
      else            {  bEndReached = (m_nHOffset > m_nEndPos);  }
      if (bEndReached) {
         if (m_bDynLoadServer) {
            // get the next line of text from the text server
            m_Text = TextServer.getText();
            extractURL(m_Text);
         }

         if (m_Text == null) {
            // reset the text file by calling initText
            if (m_bDynLoadServer &&
            (m_DTClass.equalsIgnoreCase(sTextFromFileClass))) {
               TextServer.initText(getDocumentBase(), m_TFile, 0, 0);
            }
            m_Text = "";
         }
         else {  m_Wait = m_PDelay;  }
         setStartAndEndPos();
      }

   } // end of method AdjustHOffset

   // adjust the text rectangle size and position
   //--------------------------------------------------------------------------
   private void AdjustTextRect()  {

      int xm = m_BThickness * 2;
      int xn = xm + (m_BMargin * 2);

      if (m_textBounds == null)  {
         m_textBounds = new Rectangle(m_origBounds.x, m_origBounds.y,
            m_origBounds.width, m_origBounds.height);
      }
      if (m_origBounds.width < xm)  {
         m_BThickness = m_origBounds.width / 2;
         m_BMargin = 0;
      }
      else  {
         if (m_origBounds.width < xn)  {  m_BMargin = 0;  }
      }
      if (m_origBounds.height < xm)  {
         m_BThickness = m_origBounds.height / 2;
         m_BMargin = 0;
      }
      else  {
         if (m_origBounds.height < xn)  {  m_BMargin = 0;  }
      }

      xm = m_BThickness + m_BMargin;
      xn = xm * 2;
      m_textBounds.x = xm;
      m_textBounds.y = xm;
      m_textBounds.width = m_origBounds.width - xn;
      m_textBounds.height = m_origBounds.height - xn;

   } // end of method AdjustTextRect

   // Paint the text within the text window boundaries.
   // Draw a shadow if requested, and change color when the mouse is over the
   // window rectangle.
   //--------------------------------------------------------------------------
   synchronized private void PaintData(Graphics g)  {

      // Shrink window size to exclude the frame
      g.clipRect(m_textBounds.x, m_textBounds.y,
            m_textBounds.width, m_textBounds.height);

      // repaint the data
      int nSOffset = Math.abs(m_nShade);
      int nVOffset = m_textBounds.height;
      nVOffset = (nVOffset - m_TSize - nSOffset) / 2;
      nVOffset = nVOffset + m_nVOffset + m_TSize;
      if (m_ShadeWidth > 0)  {
         int i,d;
         int R = d = m_BGColor.getRed();
         int B = m_BGColor.getBlue();  if (B>d) d = B;
         int G = m_BGColor.getGreen();  if (G>d) d = G;
         d = (m_ShadeWidth>1) ?
            (d / (m_ShadeWidth * 6)) :
            (d / (m_ShadeWidth * 4));
         for (i=m_ShadeWidth; i>0; i--) {
            R = (R>d) ? R-d : 0;
            B = (B>d) ? B-d : 0;
            G = (G>d) ? G-d : 0;
            g.setColor(new Color(R,G,B));
            d *= 1.15;
            if (i>1)  {
               // for shadow width > 1 only, shadow width 0 means: no shadow.
               int x,y;
               for (x=i; x>=-i; x--)  {
                  for (y=i; y>=-i; y--)  {
                     g.drawString(m_Text, m_nHOffset+m_ShadeDist+x,
                        m_textBounds.y+nVOffset+m_ShadeDist+y);
                  }  // for (y=i; y>=-i; y--)
               }  // for (x=i; x>=-i; x--)
            }  // (i>1)
            else  {
               g.drawString(m_Text, m_nHOffset+m_ShadeDist,
                  m_textBounds.y+nVOffset+m_ShadeDist);
            }
         }  // for (i=m_ShadeWidth;i>0;i--)
      }  // (m_ShadeWidth > 0)
      if (m_bMouseOver && (m_URL.length() > 0)) {
         if (m_THColor != null) {  g.setColor(m_THColor);  }
      }
      else {
         if (m_TColor != null) {  g.setColor(m_TColor);  }
      }
      g.drawString(m_Text, m_nHOffset, m_textBounds.y+nVOffset);
      if ((m_Direction < 1) || (m_Spacing > 0))  {
         m_nHOffset += (m_Spacing * m_Step);
      }

      // Restore window size to its original size
      g.clipRect(m_origBounds.x, m_origBounds.y,
         m_origBounds.width, m_origBounds.height);

      AdjustHOffset();

   } // end of method PaintData

   // Standard method: called when the applet starts; instantiate a thread
   //--------------------------------------------------------------------------
   public void start()  {

      if (m_tickerThread == null)  {
			m_tickerThread = new Thread(this);
			m_tickerThread.start();
		}
	} // end of method start


   // Standard method: stops the applet (called before destruction);
   // cancel any threads started
   //--------------------------------------------------------------------------
	public void stop()  {

      m_tickerThread.stop();
		m_tickerThread = null;

	} // end of method stop


   // Standard method: runs the applet; periodically update the offscreen
   // buffer and copy it to the screen to avoid flicker.
   //--------------------------------------------------------------------------
   public void run()  {
      // calculate the proper time to delay
      if (m_Rate <= 0)  {  m_Rate = 12;  }
      int nSleepTime = (m_Rate < 1001) ? (1000 / m_Rate) : 1;
	   if (m_Text != null)  {  repaint();  }

      while (true)  {  // do forever ... (i.e. a stop() command issued)
			try  {
            // wait at page end
  			   if (m_Wait > 0) {
               Thread.sleep(m_Wait);
		         m_Wait = 0;
            }

            // update the applet's window
			   if (m_Text != null) { repaint(); }

				// pause, then resume
				Thread.sleep(nSleepTime);
         }
			catch (InterruptedException e)  {  stop();  }
      } // while (true)

	} // end of method run


   // Standard method: event: the mouse enters the applet window
   //--------------------------------------------------------------------------
   public boolean mouseEnter(Event ev, int x, int y)  {

      m_bMouseOver = true;
      if (m_URL.length() > 0) {  showStatus(m_URL);  }
      return true;

   } // end of method mouseEnter


   // Standard method: event: the mouse leaves the applet window
   //--------------------------------------------------------------------------
   public boolean mouseExit(Event ev, int x, int y)  {

      m_bMouseOver = false;
      if (m_URL.length() > 0) {  showStatus("");  }
      return true;
   } // end of method mouseExit

   // Standard event method: the mouse button has been pressed by the user;
   // if an URL has been specified, proceed correspondingly
   //--------------------------------------------------------------------------
   public boolean mouseDown(Event ev, int x, int y)  {

      AppletContext oAC;
      URL oURL;

//    if ((ev.ALT_MASK != 0) | (ev.META_MASK != 0)) { return true; }
      try  {
         if (m_URL != null)  {
            oURL = new URL(m_URL);
            oAC = this.getAppletContext();
            oAC.showDocument(oURL, m_Target);
         }
      }
      catch (MalformedURLException e)  { }
      return true;

   } // end of method mouseDown

   // resize the off-screen image (if necessary)
   //--------------------------------------------------------------------------
   private void ResizeImage()  {
      // get the size of the applet's window
      m_origBounds = this.getBounds();
      // compare that to the size of our image;
      // if it hasn't changed...
      if (m_dimImage != null &&
       m_dimImage.width == m_origBounds.width &&
       m_dimImage.height== m_origBounds.height)  {
         // ...don't do anything
         return;
      }

      AdjustTextRect();
      setStartAndEndPos();
      AdjustHOffset();

      // create a graphics image to paint to
      m_dimImage = new Dimension(m_origBounds.width, m_origBounds.height);
      m_image = createImage(m_origBounds.width, m_origBounds.height);
      m_g = m_image.getGraphics();

   } // end of method ResizeImage


} // End of class ticker

