#!/usr/bin/perl

# =====================================================================
# Module:     setlogent.cgi
# Language:   PERL script
# Author:     Hans E. Herger, methodica herger & krasznai,
#             http://www.methodica.ch
# Copyright:  2002, methodica herger & krasznai, All rights reserved
# Disclaimer: This script is freeware, so anyone may use it. It may
#             be distributed and modified as long as no one is charged
#             for it and as long as this notice is not removed or
#             modified.
#             Methodica and the author may under no circumstances ever
#             be made responsible for any failure of or damage caused
#             by this script. Since it's source code is published you
#             may convince yourself that it does not contain offending
#             code. Where this absolute disclosure of responsibility
#             is not not legal the script may not be used at all.
#
# These parameters are to be set correctly by you:
#    The server root path
$serverRoot="/home/yourdomain/Web";
#    The server name
$httpRoot="www.yourdomain.com";
#    Log entry template (for a list of all variable references see "sub expandedLine")
$logtempl = "%HOST% - %USER% [%CDATE%:%CTIME%] \"%MODE% - %PROT%\" - - \"-\" \"%TEXT%  Agent: %USRA%\"";
#    Maximal log file size in bytes, note: can be overwritten by requestor
$inmxlfsize = 50000;
#    Log file name and extension
$applfname = "applet";
$applfext = "log";

# =====================================================================

use File::Basename;
use Fcntl;

# Mainline code =======================================================

$ENV{'SCRIPT_NAME'} =~ m#(/.*/)(.*)$#;
$SCRIPTDIR = $1;
$SCRIPT = $2;

($sec,$min,$hour,$mday,$mon,$cyear,$wday,$yday,$isdst) = localtime(time);
$cyear += 1900;
$mon++;
$cdate = "$cyear-" . (($mon>9) ? "$mon-" : "0$mon-") . (($mday>9) ? "$mday" : "0$mday");
$ctime = (($hour>9) ? "$hour:" : "0$hour:") . (($min>9) ? "$min:" : "0$min:") . (($sec>9) ? "$sec" : "0$sec");
$now = "$cdate:$ctime";

@fields=();

&cgi_receive;        # get CGI parameters
&cgi_decode;         # decode them and make them safe
&cgi_header;         # write the CGI header

$root .= "/" unless (substr($root,length($root)-1) eq "/");
$root = ("/" . $root) unless (substr($root,0,1) eq "/");

$serverRoot = $FORM{"sroot"} if ($FORM{"sroot"});
$lg = length($serverRoot);
$serverRoot = substr($serverRoot, 0, lg-2) if (substr($serverRoot,lg-1) eq "/");
$httpRoot = $FORM{"hroot"} if ($FORM{"hroot"});
$lg = length($httpRoot);
$httpRoot = substr($httpRoot, 0, lg-2) if (substr($httpRoot,lg-1) eq "/");

$serverRoot .= $root;
$httpRoot .= $root;

$host = $ENV{'REMOTE_HOST'};   $host = $ENV{'REMOTE_ADDR'} unless $host;
$user = $ENV{'REMOTE_USER'};   $user = "-" unless $user;
$mode = $ENV{'REQUEST_METHOD'};
$refr = $ENV{'HTTP_REFERER'};  $refr = "-" unless $refr;
$usra = $ENV{'HTTP_USER_AGENT'}; $usra = "-" unless $usra;
# $path = $ENV{'PATH_INFO'};
$path = "$1$2";
$qs = $ENV{'QUERY_STRING'};
$path .= "?$qs" if $qs;
$prot = $ENV{'SERVER_PROTOCOL'};
$text = $FORM{'TEXT'};   $text = "-" unless $text;
$mxlfsize = $FORM{'MAXSIZE'};  $mxlfsize = $inmxlfsize unless $mxlfsize;
$logfname = $serverRoot . $applfname . "." . $applfext;

$res = sysopen(FH, $logfname, O_APPEND|O_WRONLY|O_CREAT, 0600);
if ($res==1)
{
	@finfo = stat(FH);
	if ($finfo[7] > $mxlfsize)
	{
	   close(FH);
	   $ix = 9;
	   $fn = $serverRoot . $applfname . "_$ix" . "." . $applfext;
	   unlink($fn);
	   while ($ix > 0)
	   {
	   		$ix--;
	   		$fn = $serverRoot . $applfname . "_"  . $ix . "." . $applfext;
	   		$nfn = $serverRoot . $applfname . "_" . ($ix+1) . "." . $applfext;
	   		rename($fn, $nfn);
	   }
	   rename($logfname, $fn);
	   $res = sysopen(FH, $logfname, O_APPEND|O_WRONLY|O_CREAT, 0600);
	}
	if ($res==1)
	{
		$selsav = select(FH);
		print &expandedLine($logtempl) . "\n";
		select($selsav);
		close(FH);
	}
}

# subroutines =========================================================

# decode the query string and strip potentially dangerous code
sub cgi_decode {
     $incoming =~ tr/+/ /;
     $incoming =~ s/%([A-F0-9][A-F0-9])/pack("C", hex($1))/gie;

     #### Strip out semicolons unless for special character
     $incoming =~ s/;/$$/g;
     $incoming =~ s/&(\S{1,6})$$/&\1;/g;
     $incoming =~ s/$$/ /g;

     $incoming =~ s/\|/ /g;
     $incoming =~ s/^!/ /g; ## Allow exclamation points in sentences

    @pairs = split(/&/, $incoming);

    foreach (@pairs)
    {
        ($name, $value) = split(/=/, $_);

        $name  =~ tr/+/ /;
        $value =~ tr/+/ /;
        $name  = uc($name);
        $name  =~ s/%([A-F0-9][A-F0-9])/pack("C", hex($1))/gie;
        $value =~ s/%([A-F0-9][A-F0-9])/pack("C", hex($1))/gie;

        # Strip out semicolons unless for special character
        $value =~ s/;/$$/g;
        $value =~ s/&(\S{1,6})$$/&\1;/g;
        $value =~ s/$$/ /g;

        $value =~ s/\|/ /g;
        $value =~ s/^!/ /g; ## Allow exclamation points in sentences

		# assume log text, if no parameter name
 		if (($value eq "") && !($name eq ""))
		{
			$value = $name;
			$name = "TEXT";
		}

        next if ($value eq "");

        $FORM{$name} .= ", " if ($FORM{$name}); # allow for multiple values
        $FORM{$name} .= $value;

        push (@fields, $name) unless (grep(/^$name$/, @fields));
    }
}

# print a standard CGI header
sub cgi_header {
    print "Content-type: text/html\n";
    print "\n" unless ($FORM{'next-url'});
}

# get the query string sent
sub cgi_receive {
	$incoming = $ENV{'QUERY_STRING'};
}

sub expandedLine
{
	my ($txt) = @_;
	{
		# All variable references (%..%) are replaced here.
		$txt =~ s/\%HOST\%/$host/ig;
		$txt =~ s/\%USER\%/$user/ig;
		$txt =~ s/\%CDATE\%/$cdate/ig;
		$txt =~ s/\%CTIME\%/$ctime/ig;
		$txt =~ s/\%NOW\%/$now/ig;
		$txt =~ s/\%MODE\%/$mode/ig;
		$txt =~ s/\%PATH\%/$path/ig;
		$txt =~ s/\%PROT\%/$prot/ig;
		$txt =~ s/\%REFR\%/$refr/ig;
		$txt =~ s/\%USRA\%/$usra/ig;
		$txt =~ s/\%TEXT\%/$text/ig;
	}
	return $txt;
}
